package matrices2;

import matrices.Matrix;
import matrices.MatrixUtil;
import matrices.StatUtil;

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveTask;

public class Matrix075 extends RecursiveTask<Double> {
    private static final long serialVersionUID = 2613196985818202539L;
    private final Matrix matrix;

    public Matrix075(Matrix matrix) {
        this.matrix = matrix;
    }

    @Override
    protected Double compute() {
        double[][] tabl = matrix.getArray();
        int rows = tabl.length;
        int cols = tabl[0].length;
        double sum = 0.0;
        if (rows < 4) {
            for (double[] doubles : tabl) {
                sum += StatUtil.mean(doubles);
            }
        } else {
            Matrix075 a = new Matrix075(MatrixUtil.submatrix(matrix, 0,
                    rows / 2, 0, cols - 1));
            a.fork();
            Matrix075 b = new Matrix075(MatrixUtil.submatrix(matrix,
                    rows / 2 + 1, rows - 1, 0, cols - 1));
            b.fork();
            sum = a.join() + b.join();
        }
        return sum;
    }

    public static void main(String[] args) {
        ForkJoinPool pool = new ForkJoinPool();
        Matrix075 task = new Matrix075(new Matrix("matrices/assets/matrix6.txt"));
        double sum = pool.invoke(task);
        System.out.println(sum);
    }
}
